using System;
using System.Text ;

namespace shobonjtag
{
	/// <summary>
	/// JTAG |[g̃hCu
	/// 
	/// QlF CQ oŎЁuJTAG eXg̊bƉpv
	///            ISBN4-7898-3682-7
	/// </summary>
	public class JtagPort
	{
		/// <summary>
		/// gp Cable ڑIuWFNg
		/// </summary>
		JtagCable jc ;

		/// <summary>
		/// JTAG |[g̍쐬
		/// </summary>
		/// <param name="jt">gp Cable IuWFNg</param>
		public JtagPort(JtagCable j) {
			jc = j ;
		}

		/// <summary>
		/// JTAG |[gƂ 1 rbgo (Ql{ 68P)
		/// </summary>
		/// <param name="tms">TMS ̏o (1:H,0:L)</param>
		/// <param name="tdi">TDI ̏o (1:H,0:L)</param>
		/// <returns>TDO ̒l(1:H,0:L)</returns>
		public int Bitio(int tms,int tdi) {
			int tdo  ;
			jc.Tcklow() ;			// TCK 
			// CPU foCXɂĂ͂ɃfBCKvȏꍇ邩
			tdo = jc.Tdoread() ;	// TDO 
			jc.Tdiout(tms,tdi) ;	// TMS,TDI o
			jc.Tckhigh() ;			// TCK グ
			// CPU foCXɂĂ͂ɃfBCKvȏꍇ邩
			// Pentium-M1.6G ŒAJIT HԂTCK=HԂ̎1us(=0.5MHz)łB
			// ̂ Win32DLL Ɉڂꍇ̓Xs[h̏oɒ(EցEj
			return tdo ;
		}

		/// <summary>
		/// Test-Logic-Reset->Run-Test/Idle Ԃɂ
		/// Ql bsreset() ֐
		/// </summary>
		public void RunTestIdle() {
			// TMS=1 ̏Ԃ TCLK  5 TCN
			Bitio(1,1) ; // TMS=1,TDI=1 
			Bitio(1,1) ; // TMS=1,TDI=1 
			Bitio(1,1) ; // TMS=1,TDI=1 
			Bitio(1,1) ; // TMS=1,TDI=1 
			Bitio(1,1) ; // TMS=1,TDI=1 
			// ܂ł Test-Logic-Reset 
			Bitio(0,1) ; // TMS=0,TDI=1
			// ܂ł Run-Test-Idle 
		}

		/// <summary>
		/// CXgNVpX֐
		/// (Ql 82P , Xg 4-13)
		/// </summary>
		/// <param name="inst">IR ɏl(B"0000000101" Ȃ)</param>
		/// <returns>IR ǂݏol(B"0101010101" Ȃǁj</returns>
		public String InstPath(String inst) {
			int i ;

			// TDO ̓̓obt@𖞂ĂiƂ肠o͒lŁj
			StringBuilder sb = new StringBuilder(inst) ; 
			
			// Run-Test-Idle ł邱ƂO
			//    TMS TDI
			Bitio(1  ,1  ) ; // Run-Test-Idle --> Select-DR-Scan
			Bitio(1  ,1  ) ; //               --> Select-IR-Scan
			Bitio(0  ,1  ) ; //               --> Capture-IR
			Bitio(0  ,1  ) ; //               --> Shift-IR

			for (i=inst.Length-1;i>0;i--) {
				sb[i] = (char)('0' + Bitio(0,(int)inst[i]-'0')) ;
			}
			sb[0] = (char)('0' + Bitio(1,(int)inst[0]-'0')) ;
			Bitio(1  ,1  ) ; //               --> Update-IR
			Bitio(0  ,1  ) ; //               --> Run-Test-Idle
			Bitio(0  ,1  ) ; // Qlɂ͂ȂɂivQjbs() B񂩂B
			
			return sb.ToString() ;
		}

		/// <summary>
		/// f[^pX֐
		/// (Ql 85P , Xg 4-16)
		/// </summary>
		/// <param name="data">DR ɏl(B"0000000101" Ȃ)</param>
		/// <returns>DR ǂݏol(B"0101010101" Ȃǁj</returns>
		public String DataPath(String data) {
			int i ;

			// TDO ̓̓obt@𖞂ĂiƂ肠o͒lŁj
			StringBuilder sb = new StringBuilder(data) ; 
			
			// Run-Test-Idle ł邱ƂO
			//    TMS TDI
			Bitio(1  ,1  ) ; // Run-Test-Idle --> Select-DR-Scan
			Bitio(0  ,1  ) ; //               --> Capture-DR
			Bitio(0  ,1  ) ; //               --> Shift-DR

			for (i=data.Length-1;i>0;i--) {
				sb[i] = (char)('0' + Bitio(0,(int)data[i]-'0')) ;
			}
			sb[0] = (char)('0' + Bitio(1,(int)data[0]-'0')) ;
			Bitio(1  ,1  ) ; //               --> Update-DR
			Bitio(0  ,1  ) ; //               --> Run-Test-Idle
			
			return sb.ToString() ;
		}
	}
}
