using System;
using System.Collections ;
using System.Collections.Specialized ;

namespace shobonjtag
{
	/// <summary>
	/// foCXp[^`NX interface JtagDevice pč܂
	///
	/// xcf01s_vo20 ̃foCXp[^`
	/// </summary>
	public class xcf01s_vo20 : JtagDevice
	{
		/// <summary>
		/// tH[
		/// </summary>
		ViewForm vf ;

		/// <summary>
		/// CXgNVe[u
		/// </summary>
		static StringDictionary inst ;

		/// <summary>
		/// CXgNVe[u(Hashtable)ĕԂ
		/// </summary>
		/// <returns>e[û</returns>
		static StringDictionary CreateInstruction() {
			StringDictionary sd = new StringDictionary() ;
			//       "BYPASS (11111111)," &
			sd.Add( "BYPASS","11111111") ;
			//	    "SAMPLE  (00000001)," &
			sd.Add( "SAMPLE","00000001") ;
			//	    "EXTEST  (00000000)," &
			sd.Add( "EXTEST","00000000") ;
			//	    "IDCODE  (11111110)," &
			sd.Add( "IDCODE","11111110") ;
			//	   "USERCODE  (11111101)," &
			sd.Add("USERCODE","11111101") ;
			//	   "HIGHZ  (11111100)," &
			sd.Add("HIGHZ","11111100") ;

			// c͉ɂȂƂɎ

			//	"CLAMP (11111010)," &
			//	"ISPEN (11101000)," &
			//	"ISPENC (11101001)," &
			//	"FPGM (11101010)," &
			//	"FADDR (11101011)," &
			//	"FVFY0 (11101111)," &
			//	"FVFY1 (11111000)," &
			//	"FVFY3 (11100010)," &
			//	"FVFY6 (11100110)," &
			//	"FERASE (11101100)," &
			//	"SERASE (00001010)," &
			//	"FDATA0 (11101101)," &
			//	"FDATA3 (11110011)," &
			//	"FBLANK0 (11100101)," &
			//	"FBLANK3 (11100001)," &
			//	"FBLANK6 (11100100)," &
			//	"NORMRST (11110000)," &
			//	"CONFIG (11101110)," &
			//	"priv1 (11110001)," &
			//	"ISCTESTSTATUS (11100011)," &
			//	"priv3 (11100111)," &
			//	"priv4 (11110110)," &
			//	"priv5 (11100000)," &
			//	"priv6 (11110111)," &
			//	"priv7 (11110010)," &
			//	"ISCCLRSTATUS (11110100)," &
			//	"priv9 (11110101)";
			return sd ;
		}

		public xcf01s_vo20()
		{
			// 
			// TODO: RXgN^ WbNɒǉĂB
			//
			if (inst == null) {
				inst = CreateInstruction() ;
			}
		}

		#region JtagDevice o

		public String LSINAME {
			get {
				return "xcf01s_vo20" ;
			}
		}

		public double TAP_SCAN_CLOCK {
			get {
				return 10.00e+06 ;
			}
		}

		public int INSTRUCTION_LENGTH {
			get {
				return 8 ;
			}
		}

		public StringDictionary INSTRUCTION_OPCODE {
			get {
				return inst ; // RXgN^łƍĕԂ
			}
		}

		public String INSTRUCTION_CAPTURE {
			get {
				return "XXXXX001" ;
			}
		}

		public int BOUNDARY_LENGTH {
			get {
				return 25;
			}
		}

		public String GetInstruction(String instType) {
			return inst[instType] ;
		}

		public void showViewForm() {
			if (vf == null) {
				vf = new ViewForm(LSINAME) ; 
			}
			vf.Show() ;
		}

		public void disposeViewForm() {
			if (vf != null) {
				vf.Close() ;
				vf = null ;
			}
		}
		#endregion

		#region SignalListener o

		public void SendSignal(string signalvector) {
			if (vf != null) {
				SignalListener sl = vf as SignalListener;
				sl.SendSignal(signalvector) ;
			}
		}

		#endregion
	}
}
