using System;
using System.Collections ;
using System.Collections.Specialized ;

namespace shobonjtag
{
	/// <summary>
	/// foCXp[^`NX interface JtagDevice pč܂
	///
	/// EPF10K10LC84 ̃foCXp[^`
	/// </summary>
	public class EPF10K10LC84 : JtagDevice
	{
		/// <summary>
		/// tH[
		/// </summary>
		ViewForm vf ;

		/// <summary>
		/// CXgNVe[u
		/// </summary>
		static StringDictionary inst ;

		/// <summary>
		/// CXgNVe[u(Hashtable)ĕԂ
		/// </summary>
		/// <returns>e[û</returns>
		static StringDictionary CreateInstruction() {
			StringDictionary sd = new StringDictionary() ;
			//"BYPASS            (1111111111), "&
				sd.Add( "BYPASS","1111111111") ;
			//	"EXTEST          (0000000000), "&
				sd.Add( "EXTEST","0000000000") ;
			//	"SAMPLE          (0001010101), "&
				sd.Add( "SAMPLE","0001010101") ;
			//	"IDCODE            (0000000110), "&
				sd.Add( "IDCODE",  "0000000110") ;
			//	"USERCODE          (0000000111)";
				sd.Add( "USERCODE","0000000111") ;
			return sd ;
		}

		public EPF10K10LC84()
		{
			// 
			// TODO: RXgN^ WbNɒǉĂB
			//
			if (inst == null) {
				inst = CreateInstruction() ;
			}
		}

		#region JtagDevice o

		public String LSINAME {
			get {
				// TODO:  EPF10K10LC84.LSINAME getter ǉ܂B
				return "EPF10K10(PLCC84)" ;
			}
		}

		public double TAP_SCAN_CLOCK {
			get {
				// TODO:  EPF10K10LC84.TAP_SCAN_CLOCK getter ǉ܂B
				return 10.00e06 ;
			}
		}

		public int INSTRUCTION_LENGTH {
			get {
				// TODO:  EPF10K10LC84.INSTRUCTION_LENGTH getter ǉ܂B
				return 10 ;
			}
		}

		public StringDictionary INSTRUCTION_OPCODE {
			get {
				// TODO:  EPF10K10LC84.INSTRUCTION_OPCODE getter ǉ܂B
				return inst ; // RXgN^łƍĕԂ
			}
		}

		public String INSTRUCTION_CAPTURE {
			get {
				// TODO:  EPF10K10LC84.INSTRUCTION_CAPTURE getter ǉ܂B
				return "0101010101" ;
			}
		}

		public int BOUNDARY_LENGTH {
			get {
				// TODO:  EPF10K10LC84.BOUNDARY_LENGTH getter ǉ܂B
				return 480 ;
			}
		}

		public String GetInstruction(String instType) {
			return inst[instType] ;
		}

		public void showViewForm() {
			if (vf == null) {
				vf = new ViewForm(LSINAME) ; 
			}
			vf.Show() ;
		}

		public void disposeViewForm() {
			if (vf != null) {
				vf.Close() ;
				vf = null ;
			}
		}

		#endregion

		#region SignalListener o

		public void SendSignal(string signalvector) {
			if (vf != null) {
				SignalListener sl = vf as SignalListener;
				sl.SendSignal(signalvector) ;
			}
		}

		#endregion
	}
}
